VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CSocket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Public SocketHandle&
Public State%
Public LocalPort&
Public RemoteHost$
Public RemotePort&
Public LineSeparator$

Public WindowProcOld&
Private WindowHandle&
Private LineBuffer$

Event Connected()
Event Closed()
Event SendComplete()
Event DataArrival(BinData() As Byte, RemoteHostIP As String)
Event LineDataArrival(LineData As String, RemoteHostIP As String)
Event Error(Error As Long, Description As String)
Event ConnectionRequest()

Private Sub Class_Initialize()

Sockets.Add Me
WindowProcOld = 0

State = sockClosed
SocketHandle = 0
LocalPort& = 0
RemoteHost$ = ""
RemotePort& = 0
LineSeparator$ = ""

End Sub

Private Sub Class_Terminate()

Disconnect
For n% = 1 To Sockets.Count
   If Sockets(n%) Is Me Then Sockets.Remove n%: Exit For
Next

End Sub

Private Sub StartWinsock()

WindowHandle& = CreateWindowEx(0&, "static", "tst", WS_OVERLAPPEDWINDOW, 5&, 1&, 200&, 100&, 0&, 0&, App.hInstance, ByVal 0&)

If usedcount% = 0 Then
   Dim StartupData As WSADataType
   If WSAStartup(257, StartupData) Then
      MsgBox "Winsock is not installed or Setup properly.", vbCritical, "Winsock Error"
      End
   End If
   'Debug.Print "LowVersion = "; Trim$(StartupData.wVersion), "HighVersion="; Trim$(StartupData.wHighVersion)
   'Debug.Print "Description = "; Trim$(StartupData.szDescription)
   'Debug.Print "SystemStatus = "; Trim$(StartupData.szSystemStatus)
   'Debug.Print "Maximum Sockets = "; Trim$(StartupData.iMaxSockets)
End If
usedcount% = usedcount% + 1

WindowProcOld& = SetWindowProc(WindowHandle&, 0)

End Sub

Private Sub EndWinsock()

SetWindowProc WindowHandle&, WindowProcOld&
WindowProcOld& = 0
DestroyWindow WindowHandle&
usedcount% = usedcount% - 1: If usedcount% = 0 Then WSACleanup

End Sub

Public Sub Connect(ByVal Host As String, ByVal Port As Long)

If SocketHandle Then Disconnect
StartWinsock

SocketHandle = 0
State = sockConnecting

Dim saZero As sockaddr
Dim sockin As sockaddr

sockin = saZero
sockin.sin_family = AF_INET
sockin.sin_port = htons(Port)
If sockin.sin_port = INVALID_SOCKET Then Disconnect: Exit Sub

sockin.sin_addr = GetHostByNameAlias(Host)
If sockin.sin_addr = INADDR_NONE Then Disconnect: Exit Sub

SocketHandle = Socket(PF_INET, SOCK_STREAM, IPPROTO_TCP): If SocketHandle <= 0 Then Disconnect: Exit Sub
If SetSockLinger(SocketHandle, 1, 0) = SOCKET_ERROR Then Disconnect: Exit Sub
If WSAAsyncSelect(SocketHandle, WindowHandle&, 2000&, FD_READ Or FD_WRITE Or FD_CONNECT Or FD_CLOSE) Then Disconnect: Exit Sub
If connectsocket(SocketHandle, sockin, sockaddr_size) <> -1 Then Disconnect: Exit Sub

End Sub

Public Sub Listen()
    
If SocketHandle Then Disconnect
StartWinsock

SocketHandle = 0
RemoteHost$ = ""
RemotePort& = 0

Dim saZero As sockaddr
Dim sockin As sockaddr
sockin = saZero     'zero out the structure
sockin.sin_family = AF_INET
sockin.sin_port = htons(LocalPort&): If sockin.sin_port = INVALID_SOCKET Then EndWinsock: Exit Sub
sockin.sin_addr = htonl(INADDR_ANY): If sockin.sin_addr = INADDR_NONE Then EndWinsock: Exit Sub

SocketHandle = Socket(PF_INET, SOCK_STREAM, IPPROTO_TCP): If SocketHandle <= 0 Then Disconnect: Exit Sub
If bind(SocketHandle, sockin, sockaddr_size) Then Disconnect: Exit Sub
If WSAAsyncSelect(SocketHandle, WindowHandle&, 2000&, FD_READ Or FD_WRITE Or FD_CLOSE Or FD_ACCEPT) Then Disconnect: Exit Sub
If listensocket(SocketHandle, 5) Then Disconnect: Exit Sub

State = sockListening

End Sub

Public Function SendData(data As Variant) As Long
SendData = 0
If SocketHandle = 0 Then Exit Function
Dim TheMsg() As Byte, sTemp$
Select Case VarType(data)
Case 8209   'byte array
   sTemp = data
Case 8      'string, if we recieve a string, its assumed we are linemode
   Line$ = data
   Log "< " + Line$
   sTemp = StrConv(Line$ + LineSeparator$, vbFromUnicode)
Case Else
   sTemp = CStr(data)
End Select
TheMsg = sTemp$
If UBound(TheMsg) > -1 Then
   SendData = send(SocketHandle, TheMsg(0), (UBound(TheMsg) - LBound(TheMsg) + 1), 0)
End If
End Function

Public Sub Disconnect()

If SocketHandle = 0 Then Exit Sub

closesocket SocketHandle
SocketHandle = 0
State = sockClosed
EndWinsock

End Sub
   
Public Sub Accept(Server As CSocket)

Dim Sock As sockaddr
StartWinsock
SocketHandle = acceptsocket(Server.SocketHandle, Sock, sockaddr_size)
RemoteHost$ = GetPeerHostByAddr(SocketHandle)
RemotePort& = GetPeerPort(SocketHandle)

End Sub
   
Public Sub WindowProc(WSAEvent As Long, data As Variant)

Select Case WSAEvent
Case 0
   er$ = data
   State = sockClosed
   RaiseEvent Error(0, er$)
Case FD_CLOSE
   State = sockClosed
   Log "closed " & RemoteHost$ & ":" & RemotePort&
   RaiseEvent Closed
   Disconnect
Case FD_CONNECT
   State = sockConnected
   RemoteHost$ = GetPeerHostByAddr(SocketHandle)
   RemotePort& = GetPeerPort(SocketHandle)
   Log ""
   Log ""
   Log ""
   Log "connected " & RemoteHost$ & ":" & RemotePort&
   RaiseEvent Connected
Case FD_ACCEPT
   RaiseEvent ConnectionRequest
Case FD_READ
   Dim b() As Byte
   b = data
   If Len(LineSeparator$) = 0 Then
      RaiseEvent DataArrival(b, RemoteHost)
   Else
      Line$ = StrConv(b, vbUnicode)
      If InStr(Line$, Chr$(0)) Then Line$ = Left$(Line$, InStr(Line$, Chr$(0)) - 1)
      LineBuffer$ = LineBuffer$ + Line$
      'Debug.Print "***"; LineBuffer$; "***": For i% = 1 To Len(LineBuffer$): Debug.Print Asc(Mid$(LineBuffer$, i%, 1));: Next: Debug.Print
      Do While InStr(LineBuffer$, LineSeparator$)
         Log "> " + Left$(LineBuffer$, InStr(LineBuffer$, LineSeparator$) - 1)
         RaiseEvent LineDataArrival(Left$(LineBuffer$, InStr(LineBuffer$, LineSeparator$) - 1), RemoteHost)
         LineBuffer$ = Mid$(LineBuffer$, InStr(LineBuffer$, LineSeparator$) + Len(LineSeparator$))
      Loop
   End If
Case FD_WRITE
   RaiseEvent SendComplete
End Select

End Sub

Private Sub Log(l$)

'f% = FreeFile: Open "log.txt" For Append As #f%: Print #f%, l$: Close #f%

End Sub
